
;===================================================================
;              MAIN.ASM of Random Numnbers
;
; 
;===================================================================
             .MODEL  LARGE
		.STACK 256
;===================================================================
                                       ;PROCEDURES TO
           
	   EXTRN   NRANDOM:FAR          ;PROCEDURE RANDOM   
           EXTRN   RESEED:FAR          ;PROCEDURE RESEED
           EXTRN   CLEAR:FAR           ;CLEAR SCREEN
           EXTRN   NEWLINE:FAR         ;DISPLAY NEWLINE CHARACTER
           EXTRN   PAUSE:FAR           ;PAUSE UNTIL KEY STROKE
           EXTRN   PUTDEC:FAR
           EXTRN   PUTSTRNG:FAR        ;DISPLAY CHARACTER STRING
;===================================================================
;DATA  S E G M E N T   D E F I N I T I O N
;
 	  .DATA

UPPER	    DW 9999 ; set value for UPPER
LOWER	    DW 0    ; set value for LOWER
COUNTEVEN   DW 0
COUNTODD    DW 0
COUNTHIGH   DW 0
COUNTLOW    DW 0
COUNTER     DW 0

HEADERHIGH  DB 'High 5000-9999: '
HEADERLOW   DB 'Low 0-4999:     '
HEADEREVEN  DB 'Even:           '
HEADERODD   DB 'ODD:            '  
SPACE	    DB ' '
PAUSE_MSG  DB      '   ANY KEY CONTINUES '
;OURSEED	    DB 'Numbers Using SEED 5555h are: '
;CLOCKSEED   DB 'Numbers USING CLOCK SEED are: '

;===================================================================
;C O D E   S E G M E N T   D E F I N I T I O N
;
           .CODE
           ASSUME  DS:DGROUP
;-------------------------------------------------------------------
MAIN PROC

        MOV  AX,DGROUP    ;SET DS-REGISTER TO POINT TO
        MOV  DS,AX               ;CONSTANT DATA SEGMENT
	MOV  BL,0
start:
	CALL RESEED
	MOV  COUNTER,100	;SET LOOP COUNTS 0 to 100
NUM_LOOP:
	MOV  CX,10	;SET TO LOOP 10 numbers per line 
LINE_LOOP:
	PUSH  CX
        MOV  AX,UPPER    ;MOVE UPPER IN AX REGISTER 9999
        PUSH AX         ; PUSH AX VALUE INTO THE STACK
	MOV  AX,LOWER    ;MOVE LOWER IN AX REGISTER 0
	PUSH AX		;PUSH AX VALUE INTO THE STACK
	
	CALL NRANDOM	;CALL PROC RANDOM
	MOV  BH,+1
	CALL PUTDEC
	LEA  DI,SPACE
	MOV  CX,1
	CALL PUTSTRNG
	CMP  AX,5000
	JAE  SEQHIGH
	INC  COUNTLOW
	JMP  SHORT HILO_COUNTER
SEQHIGH:
	INC  COUNTHIGH

HILO_COUNTER:
	SHR  AX,1
	JC   ODDS
	INC  COUNTEVEN
	JMP  SHORT EVENODD_COUNTER
ODDS:
	INC  COUNTODD
EVENODD_COUNTER:
	POP  CX
	LOOP LINE_LOOP
	CALL NEWLINE
	SUB  COUNTER,10
	CMP  COUNTER,0
	MOV AX,DGROUP
	MOV  ES,AX
	JNE  NUM_LOOP
	
; ======= PRINT STATISTIC OF NUMBERS ON SCREEN========
		
	
	
	CALL NEWLINE
	INC  BL
	CMP  BL,1
	JE   START
	CALL NEWLINE
	CALL NEWLINE
	
	LEA  DI,HEADERHIGH
	MOV  CX,16
	CALL PUTSTRNG
	MOV  AX, COUNTHIGH
	CALL PUTDEC
	CALL NEWLINE

	LEA  DI,HEADERLOW
	MOV  CX,16
	CALL PUTSTRNG
	MOV  AX,COUNTLOW
	CALL PUTDEC
	CALL NEWLINE

	LEA  DI,HEADEREVEN
	MOV  CX,16
	CALL PUTSTRNG
	MOV  AX,COUNTEVEN
	CALL PUTDEC
	CALL NEWLINE
	
	LEA DI,HEADERODD
	MOV CX,16
	CALL PUTSTRNG
	MOV AX, COUNTODD
	CALL PUTDEC
	CALL NEWLINE
	
	CALL    NEWLINE             ;   DISPLAY NEWLINE CHAR.
	LEA     DI,PAUSE_MSG        ;   PAUSE AND WAIT FOR 
        MOV     CX,21               ;   KEY STROKE
        CALL    PAUSE

	        

;========= END PRINT STATISTIC OF NUMBERS ON SCREEN ;
 .exit
MAIN ENDP                        
        END MAIN




	